/* Entry Point */
ENTRY(_start)


/* Specify the memory areas */
MEMORY {
  RAM (xrw)       : ORIGIN = 0x20000000, LENGTH = 4K
}

/* Define output sections */
SECTIONS {

  /* The program code and other data goes into FLASH */
  .text : {
    . = ALIGN(4);
    _start = .;
    *(.text)           /* .text sections (code) */
    *(.text*)          /* .text* sections (code) */
    *(.rodata)         /* .rodata sections (constants, strings, etc.) */
    *(.rodata*)        /* .rodata* sections (constants, strings, etc.) */
  } >RAM
  _sidata = .;
  .data : AT (_sidata){
    . = ALIGN(4);
    *(.data)           /* .data sections */
    *(.data*)          /* .data* sections */
  } >RAM
  .bss : {
    . = ALIGN(4);
    *(.bss)
    *(.bss*)
    *(COMMON)
  } >RAM
  /* Remove information from the standard libraries */
  /DISCARD/ : {
  }
}
